-- name: [CS] Link64
-- description: Hyrule's savior is here!\n\n\\#ff7777\\This Pack requires Character Select\nto use as a Library!

--[[
    API Documentation for Character Select can be found below:
    https://github.com/Squishy6094/character-select-coop/wiki/API-Documentation

    Use this if you're curious on how anything here wo)rks >v<
	(This is an edited version of the Template File by Squishy)
]]

local TEXT_MOD_NAME = "Link64"

-- Stops mod from loading if Character Select isn't on
if not _G.charSelectExists then
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
    return 0
end

local E_MODEL_Link64 = smlua_model_util_get_id("link64_geo")
local Link_Life_Icon = get_texture_info("link64icon")
local E_MODEL_DarkLink64 = smlua_model_util_get_id("drklink64_geo")
local DarkLink_Life_Icon = get_texture_info("darklink64icon")
local E_MODEL_TRIFORCE = smlua_model_util_get_id("triforce_geo")
local Triforce_Icon = get_texture_info("tricon")


-- SFX Brought to you by dayjo.org, The Sounds Resource and me through audacity
local VOICETABLE_LINK64 = {
    --[CHAR_SOUND_OKEY_DOKEY] = 'OOT_Secret.ogg', -- Starting game
	[CHAR_SOUND_LETS_A_GO] = 'Silent.ogg', -- Starting level
	[CHAR_SOUND_PUNCH_YAH] = 'WW_Link_Attack1.ogg', -- Punch 1
	[CHAR_SOUND_PUNCH_WAH] = 'WW_Link_Attack4.ogg', -- Punch 2
	[CHAR_SOUND_PUNCH_HOO] = 'WW_Link_PowerAttack3.ogg', -- Punch 3
	[CHAR_SOUND_YAH_WAH_HOO] = {'WW_Link_Hop1.ogg', 'WW_Link_Hop2.ogg'}, -- First/Second jump sounds
	[CHAR_SOUND_HOOHOO] = 'WW_Link_Jump3.ogg', -- Third jump sound
	[CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'WW_Link_Jump2.ogg', 'WW_Link_PowerAttack3.ogg'}, -- Triple jump sounds
	[CHAR_SOUND_UH] = 'WW_Link_Crash3.ogg', -- Wall bonk
	[CHAR_SOUND_UH2] = 'WW_Link_Lift2.ogg', -- Landing after long jump
	[CHAR_SOUND_UH2_2] = 'WW_Link_Lift2.ogg', -- Same sound as UH2; jumping onto ledge
	[CHAR_SOUND_HAHA] = 'WW_Link_Yay.ogg', -- Landing triple jump
	[CHAR_SOUND_YAHOO] = 'WW_Link_Throw2.ogg', -- Long jump
	[CHAR_SOUND_DOH] = 'WW_Link_KnockDown2.ogg', -- Long jump wall bonk
	[CHAR_SOUND_WHOA] = 'WW_Link_Lift1.ogg', -- Grabbing ledge
	[CHAR_SOUND_EEUH] = 'WW_Link_LedgeClimb1.ogg', -- Climbing over ledge
	[CHAR_SOUND_WAAAOOOW] = 'WW_Link_Fall.ogg', -- Falling a long distance
	[CHAR_SOUND_TWIRL_BOUNCE] = 'WW_Link_Yay.ogg', -- Bouncing off of a flower spring
	[CHAR_SOUND_GROUND_POUND_WAH] = 'WW_Link_PowerAttack1.ogg', 
	[CHAR_SOUND_HRMM] = 'WW_Link_Lift1.ogg', -- Lifting something
	[CHAR_SOUND_HERE_WE_GO] = 'Silent.ogg', -- Star get
	[CHAR_SOUND_SO_LONGA_BOWSER] = 'WW_Link_FinalBlow.ogg', -- Throwing Bowser
	[CHAR_SOUND_ATTACKED] = 'WW_Link_Hurt2.ogg', -- Damaged
	[CHAR_SOUND_PANTING] = 'WW_Link_Breathe2.ogg', -- Low health
	[CHAR_SOUND_ON_FIRE] = 'WW_Link_HotCold2.ogg', -- Burned
	[CHAR_SOUND_IMA_TIRED] = 'Silent.ogg', -- Mario feeling tired
	[CHAR_SOUND_YAWNING] = 'Silent.ogg', -- Mario yawning before he sits down to sleep
	[CHAR_SOUND_SNORING1] = 'Silent.ogg', -- Snore Inhale
	[CHAR_SOUND_SNORING2] = 'Silent.ogg', -- Exhale
	[CHAR_SOUND_SNORING3] = 'WW_Link_Awaken.ogg', -- Sleep talking / mumbling
	[CHAR_SOUND_COUGHING1] = 'WW_Link_Choke1.ogg', -- Cough take 1
	[CHAR_SOUND_COUGHING2] = 'Silent.ogg', -- Cough take 2
	[CHAR_SOUND_COUGHING3] = 'Silent.ogg', -- Cough take 3
	[CHAR_SOUND_DYING] = 'WW_Link_Die1.ogg', -- Dying from damage
	[CHAR_SOUND_DROWNING] = 'WW_Link_Drown.ogg', -- Running out of air underwater
	[CHAR_SOUND_MAMA_MIA] = 'WW_Link_Hurt3.ogg' -- Booted out of level
}

local VOICETABLE_DARKLINK = {
[CHAR_SOUND_OKEY_DOKEY] = 'DarkLinkAppears.ogg', -- Starting game
	[CHAR_SOUND_LETS_A_GO] = 'Silent.ogg', -- Starting level
	[CHAR_SOUND_PUNCH_YAH] = 'DarkLink_Attack1.ogg', -- Punch 1
	[CHAR_SOUND_PUNCH_WAH] = 'DarkLink_Attack4.ogg', -- Punch 2
	[CHAR_SOUND_PUNCH_HOO] = 'DarkLink_PowerAttack3.ogg', -- Punch 3
	[CHAR_SOUND_YAH_WAH_HOO] = {'DarkLink_Hop1.ogg', 'DarkLink_Hop2.ogg'}, -- First/Second jump sounds
	[CHAR_SOUND_HOOHOO] = 'DarkLink_Jump3.ogg', -- Third jump sound
	[CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'DarkLink_Jump2.ogg', 'DarkLink_PowerAttack3.ogg'}, -- Triple jump sounds
	[CHAR_SOUND_UH] = 'DarkLink_Crash3.ogg', -- Wall bonk
	[CHAR_SOUND_UH2] = 'DarkLink_Lift2.ogg', -- Landing after long jump
	[CHAR_SOUND_UH2_2] = 'DarkLink_Lift2.ogg', -- Same sound as UH2; jumping onto ledge
	[CHAR_SOUND_HAHA] = 'Silent.ogg', -- Landing triple jump
	[CHAR_SOUND_YAHOO] = 'DarkLink_Throw2.ogg', -- Long jump
	[CHAR_SOUND_DOH] = 'DarkLink_KnockDown2.ogg', -- Long jump wall bonk
	[CHAR_SOUND_WHOA] = 'DarkLink_Lift1.ogg', -- Grabbing ledge
	[CHAR_SOUND_EEUH] = 'Silent.ogg', -- Climbing over ledge
	[CHAR_SOUND_WAAAOOOW] = 'DarkLink_Fall.ogg', -- Falling a long distance
	[CHAR_SOUND_TWIRL_BOUNCE] = 'Silent.ogg', -- Bouncing off of a flower spring
	[CHAR_SOUND_GROUND_POUND_WAH] = 'DarkLink_PowerAttack1.ogg', 
	[CHAR_SOUND_HRMM] = 'DarkLink_Lift1.ogg', -- Lifting something
	[CHAR_SOUND_HERE_WE_GO] = 'Silent.ogg', -- Star get
	[CHAR_SOUND_SO_LONGA_BOWSER] = 'DarkLink_FinalBlow.ogg', -- Throwing Bowser
	[CHAR_SOUND_ATTACKED] = 'DarkLink_Hurt2.ogg', -- Damaged
	[CHAR_SOUND_PANTING] = 'Silent.ogg', -- Low health
	[CHAR_SOUND_ON_FIRE] = 'DarkLink_HotCold2.ogg', -- Burned
	[CHAR_SOUND_IMA_TIRED] = 'Silent.ogg', -- Mario feeling tired
	[CHAR_SOUND_YAWNING] = 'Silent.ogg', -- Mario yawning before he sits down to sleep
	[CHAR_SOUND_SNORING1] = 'Silent.ogg', -- Snore Inhale
	[CHAR_SOUND_SNORING2] = 'Silent.ogg', -- Exhale
	[CHAR_SOUND_SNORING3] = 'Silent.ogg', -- Sleep talking / mumbling
	[CHAR_SOUND_COUGHING1] = 'Silent.ogg', -- Cough take 1
	[CHAR_SOUND_COUGHING2] = 'Silent.ogg', -- Cough take 2
	[CHAR_SOUND_COUGHING3] = 'Silent.ogg', -- Cough take 3
	[CHAR_SOUND_DYING] = 'DarkLink_Die1.ogg', -- Dying from damage
	[CHAR_SOUND_DROWNING] = 'DarkLink_Drown.ogg', -- Running out of air underwater
	[CHAR_SOUND_MAMA_MIA] = 'DarkLink_Hurt3.ogg' -- Booted out of level
}

local CAPTABLE_LINK64 = {
    normal = smlua_model_util_get_id("link64normal_geo"),
    wing = smlua_model_util_get_id("link64wing_geo"),
    metal = smlua_model_util_get_id("link64metal_geo"),
}

local CAPTABLE_DARKLINK = {
    normal = smlua_model_util_get_id("drklink64normal_geo"),
    wing = smlua_model_util_get_id("drklink64wing_geo"),
    metal = smlua_model_util_get_id("drklink64metal_geo"),
}

local PALETTE_LINK = {
    [PANTS]  = "6FBD22",
    [SHIRT]  = "9D2F09",
    [GLOVES] = "EFEFEF",
    [SHOES]  = "9D2F09",
    [HAIR]   = "B6803E",
    [SKIN]   = "FCBB82",
    [CAP]    = "6FBD22",
	[EMBLEM] = "F9B413"
}

local PALETTE_DARKLINK = {
    [PANTS]  = "16001D",
    [SHIRT]  = "000000",
    [GLOVES] = "361F3A",
    [SHOES]  = "16001D",
    [HAIR]   = "000000",
    [SKIN]   = "16001D",
    [CAP]    = "16001D",
	[EMBLEM] = "361F3A"
}

local HM_LINK= {
    label = {
        left = get_texture_info("HealthLeft"),
        right = get_texture_info("HealthRight"),
    },
    pie = {
        [1] = get_texture_info("Pie1"),
        [2] = get_texture_info("Pie2"),
        [3] = get_texture_info("Pie3"),
        [4] = get_texture_info("Pie4"),
        [5] = get_texture_info("Pie5"),
        [6] = get_texture_info("Pie6"),
        [7] = get_texture_info("Pie7"),
        [8] = get_texture_info("Pie8"),
    }
}

local HM_DARKLINK= {
    label = {
        left = get_texture_info("DarkHealthLeft"),
        right = get_texture_info("DarkHealthRight"),
    },
    pie = {
        [1] = get_texture_info("DarkPie1"),
        [2] = get_texture_info("DarkPie2"),
        [3] = get_texture_info("DarkPie3"),
        [4] = get_texture_info("DarkPie4"),
        [5] = get_texture_info("DarkPie5"),
        [6] = get_texture_info("DarkPie6"),
        [7] = get_texture_info("DarkPie7"),
        [8] = get_texture_info("DarkPie8"),
    }
}


local CSloaded = false
local function on_character_select_load()
    CT_LINK = _G.charSelect.character_add("Link", {"The hero of Hyrule has come to defend the", "Triforce from the villainous King Koopa!"}, "Bwogglyswog", {r = 159, g = 255, b = 16}, E_MODEL_Link64, CT_LUIGI, Link_Life_Icon)
    _G.charSelect.character_add_caps(E_MODEL_Link64, CAPTABLE_LINK64)
    _G.charSelect.character_add_voice(E_MODEL_Link64, VOICETABLE_LINK64)
    _G.charSelect.character_add_celebration_star(E_MODEL_Link64, E_MODEL_TRIFORCE, Triforce_Icon)
    _G.charSelect.character_add_palette_preset(E_MODEL_Link64, PALETTE_LINK)
    _G.charSelect.character_add_health_meter(CT_LINK, HM_LINK)
    _G.charSelect.character_add_animations(E_MODEL_Link64, ANIMTABLE_LINK64)

    CT_DARKLINK = _G.charSelect.character_add("Dark Link", {"No matter where you go", "your shadow will follow..."}, "Bwogglyswog", {r = 120, g = 0, b = 221}, smlua_model_util_get_id("drklink64_geo"), CT_LUIGI, DarkLink_Life_Icon)
    _G.charSelect.character_add_caps(E_MODEL_DarkLink64, CAPTABLE_DARKLINK)
    _G.charSelect.character_add_voice(E_MODEL_DarkLink64, VOICETABLE_DARKLINK)
    _G.charSelect.character_add_celebration_star(E_MODEL_DarkLink64, E_MODEL_TRIFORCE, Triforce_Icon)
    _G.charSelect.character_add_palette_preset(E_MODEL_DarkLink64, PALETTE_DARKLINK)
    _G.charSelect.character_add_health_meter(CT_DARKLINK, HM_DARKLINK)
    _G.charSelect.character_add_animations(E_MODEL_DarkLink64, ANIMTABLE_LINK64)

    CSloaded = true
end

--Refrenced from mmx_v1.2.6 by ganewatch cuz I have a very weak grasp on what I'm doing

    local character_get_voice, update_sound = _G.charSelect.character_get_voice, _G.charSelect.voice.sound
    local function character_sounds(m, sound)
        local voice = _G.charSelect.character_get_voice(m)
        if voice == VOICETABLE_LINK64 or voice == VOICETABLE_DARKLINK
        then
            return update_sound(m, sound)
        end
    end

local function on_character_snore(m)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_LINK64 then return _G.charSelect.voice.snore(m) end
end

--Huge shoutout to Wall_E20 for help with the expressions

local function angry_anim(m)
    if _G.charSelect.character_get_voice(m) == VOICETABLE_LINK64 then
        if
            m.marioObj.header.gfx.animInfo.animID == MARIO_ANIM_FIRST_PUNCH or
            m.marioObj.header.gfx.animInfo.animID == MARIO_ANIM_SECOND_PUNCH or
            m.marioObj.header.gfx.animInfo.animID == MARIO_ANIM_AIR_KICK or
            m.marioObj.header.gfx.animInfo.animID == MARIO_ANIM_THROW_LIGHT_OBJECT or
            m.marioObj.header.gfx.animInfo.animID == MARIO_ANIM_GROUND_THROW or
            m.marioObj.header.gfx.animInfo.animID == MARIO_ANIM_GROUND_KICK or
            m.marioObj.header.gfx.animInfo.animID == MARIO_ANIM_BREAKDANCE or
            m.marioObj.header.gfx.animInfo.animID == MARIO_ANIM_RELEASE_BOWSER or
            m.marioObj.header.gfx.animInfo.animID == MARIO_ANIM_HEAVY_THROW or
            m.marioObj.header.gfx.animInfo.animID == MARIO_ANIM_GROUND_POUND then
            m.marioBodyState.eyeState = MARIO_EYES_LOOK_DOWN
        end
    end
end

local function happy_anim(m)
    if _G.charSelect.character_get_voice(m) == VOICETABLE_LINK64 then
        if
            m.marioObj.header.gfx.animInfo.animID == MARIO_ANIM_STAR_DANCE or
            m.marioObj.header.gfx.animInfo.animID == MARIO_ANIM_CREDITS_PEACE_SIGN or
            m.marioObj.header.gfx.animInfo.animID == MARIO_ANIM_PUT_CAP_ON or
            m.marioObj.header.gfx.animInfo.animID == MARIO_ANIM_TWIRL or
            m.marioObj.header.gfx.animInfo.animID == MARIO_ANIM_START_TWIRL or
            m.marioObj.header.gfx.animInfo.animID == MARIO_ANIM_JUMP_RIDING_SHELL or
            m.marioObj.header.gfx.animInfo.animID == MARIO_ANIM_FINAL_BOWSER_RAISE_HAND_SPIN or
            m.marioObj.header.gfx.animInfo.animID == MARIO_ANIM_FINAL_BOWSER_WING_CAP_TAKE_OFF or
            m.marioObj.header.gfx.animInfo.animID == MARIO_ANIM_CREDITS_WAVING or
            m.marioObj.header.gfx.animInfo.animID == MARIO_ANIM_TRIPLE_JUMP_LAND then
            m.marioBodyState.eyeState = MARIO_EYES_LOOK_UP
        end
    end
end

local function dead_anim(m)
    if _G.charSelect.character_get_voice(m) == VOICETABLE_LINK64 or VOICETABLE_DARKLINK then
        if
            m.marioObj.header.gfx.animInfo.animID == MARIO_ANIM_DYING_IN_QUICKSAND or
            m.marioObj.header.gfx.animInfo.animID == MARIO_ANIM_ELECTROCUTION or
            m.marioObj.header.gfx.animInfo.animID == MARIO_ANIM_SHOCKED or
            m.marioObj.header.gfx.animInfo.animID == MARIO_ANIM_MISSING_CAP or
            m.marioObj.header.gfx.animInfo.animID == MARIO_ANIM_COUGHING then
            m.marioBodyState.eyeState = MARIO_EYES_DEAD
        end
    end
end

hook_event(HOOK_ON_MODS_LOADED, on_character_select_load)
hook_event(HOOK_CHARACTER_SOUND, character_sounds)
hook_event(HOOK_MARIO_UPDATE, on_character_snore)
hook_event(HOOK_MARIO_UPDATE, angry_anim)
hook_event(HOOK_MARIO_UPDATE, happy_anim)
hook_event(HOOK_MARIO_UPDATE, dead_anim)